﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;

namespace XDGDragDropDemo
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        Random r = new Random();
        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for(int i=0; i < 10; i++)
            {
                Data.Add(new SampleData() { ID = i, Label = "Test Label " + i.ToString(), Number = r.Next(1000) });
            }

        }
    }

    public class SampleData : ObservableModel
    {
        private string _label;

        public int ID { get; set; }
        public string Label
        {
            get { return _label; }
            set
            {
                if(_label != value)
                {
                    _label = value;
                    OnPropertyChanged();
                }
            }
        }
        public int Number { get; set; }
    }

    public class ObservableModel : INotifyPropertyChanged
    {
        public event PropertyChangedEventHandler PropertyChanged;
        public void OnPropertyChanged([CallerMemberName] String propertyName = "")
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

}
